{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2019                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.MyCloudCDS;

interface

uses
  {$IFNDEF LCLTMSWEB}
  System.Classes, DB, DBClient, WEBLib.Controls, Web, jsdelphisystem, js;
  {$ENDIF}
  {$IFDEF LCLTMSWEB}
  Classes, DB, WEBLib.Controls, Web, jsdelphisystem;
  {$ENDIF}

type
  TMyCloudDbErrorEvent = procedure(Sender: TObject; errMsg: String) of object;

  TBatchUpdates = (buAuto, buManual);
  {$IFNDEF LCLTMSWEB}
  [ComponentPlatforms(TMSWebPlatform)]
  {$ENDIF}
  TWebMyCloudDbClientDataset = Class(TDataSet)
  private
    FAppKey,  FTableName, FAppCallbackURL: String;
    FOnError: TMyCloudDbErrorEvent;
    FBatchUpdates: TBatchUpdates;
  protected
    procedure InternalClose; override;
    procedure InternalHandleException; override;
    procedure InternalInitFieldDefs; override;
    procedure InternalOpen; override;
    function IsCursorOpen: Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Refresh(Force: Boolean=False); 
    procedure AddSortFieldDef(aField: String; isAscending: Boolean);
    procedure ClearSortFieldDefs;
    procedure ClearTokens;
    property BatchUpdates: TBatchUpdates read FBatchUpdates write FBatchUpdates;
  published
    property AppKey: String read FAppKey write FAppKey;
    property TableName: String read FTableName write FTableName;
    property AppCallbackURL: String read FAppCallbackURL write FAppCallbackURL;
    property OnError: TMyCloudDbErrorEvent read FOnError write FOnError;

    // Other
    property Active;
    property BeforeOpen;
    property AfterOpen;
    property BeforeClose;
    property AfterClose;
    property BeforeInsert;
    property AfterInsert;
    property BeforeEdit;
    property AfterEdit;
    property BeforePost;
    property AfterPost;
    property BeforeCancel;
    property AfterCancel;
    property BeforeDelete;
    property AfterDelete;
    property BeforeScroll;
    property AfterScroll;
    property OnCalcFields;
    property OnDeleteError;
    property OnEditError;
    property OnFilterRecord;
    property OnNewRecord;
    property OnPostError;
  end;

implementation

procedure TWebMyCloudDbClientDataset.InternalClose;
begin
  //
end;

procedure TWebMyCloudDbClientDataset.InternalHandleException;
begin
  //
end;

procedure TWebMyCloudDbClientDataset.InternalInitFieldDefs;
begin
  //
end;

procedure TWebMyCloudDbClientDataset.InternalOpen;
begin
  //
end;

function TWebMyCloudDbClientDataset.IsCursorOpen: Boolean;
begin
  Result := false;
end;

constructor TWebMyCloudDbClientDataset.Create(AOwner: TComponent);
begin
  inherited;
  FAppKey := '';
  FTableName := '';
  FAppCallbackURL := '';
end;

destructor TWebMyCloudDbClientDataset.Destroy;
begin
  inherited;
end;

procedure TWebMyCloudDbClientDataset.refresh(Force: Boolean=False);
begin
end;

procedure TWebMyCloudDbClientDataset.AddSortFieldDef(aField: String; isAscending: Boolean);
begin
end;

procedure TWebMyCloudDbClientDataset.ClearSortFieldDefs;
begin
end;

procedure TWebMyCloudDbClientDataset.ClearTokens;
begin
end;

end.
