{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018 - 2019                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.Storage;

interface

uses
  Classes;

type
  TLocalStorage = class(TObject)
  private
  protected
    procedure SetValues(AKey, AValue: string);
    function GetValues(AKey: string): string;
    function GetKey(AIndex: integer): string;
    function GetCount: integer;
  public
    property Keys[AIndex: integer]: string read GetKey;
    property Count: integer read GetCount;
    property Values[Key: string]: string read GetValues write SetValues;
    class procedure SetValue(AKey, AValue: string);
    class function GetValue(AKey: string): string;
    class procedure RemoveKey(AKey: string);
  end;

  TWebLocalStorage = class(TLocalStorage);

  TSessionStorage = class(TObject)
  private
  protected
    procedure SetValues(AKey, AValue: string);
    function GetValues(AKey: string): string;
    function GetKey(AIndex: integer): string;
    function GetCount: integer;
  public
    property Keys[AIndex: integer]: string read GetKey;
    property Count: integer read GetCount;
    property Values[key: string]: string read GetValues write SetValues;
    class procedure SetValue(AKey, AValue: string);
    class function GetValue(AKey: string): string;
  end;

  TWebSessionStorage = class(TSessionStorage);

implementation

{ TLocalStorage }

class procedure TLocalStorage.SetValue(AKey, AValue: string);
begin

end;

procedure TLocalStorage.SetValues(AKey, AValue: string);
begin
  //
end;

class function TLocalStorage.GetValue(AKey: string): string;
begin
  Result := '';
end;

function TLocalStorage.GetValues(AKey: string): string;
begin
  Result := '';
end;


class procedure TLocalStorage.RemoveKey(AKey: string);
begin
  //
end;

function TLocalStorage.GetKey(AIndex: integer): string;
begin
  Result := '';
end;

function TLocalStorage.GetCount: integer;
begin
  Result := 0;
end;


{ TSessionStorage }

class procedure TSessionStorage.SetValue(AKey, AValue: string);
begin
  //
end;

procedure TSessionStorage.SetValues(AKey, AValue: string);
begin
  //
end;

class function TSessionStorage.GetValue(AKey: string): string;
begin
  Result := '';
end;

function TSessionStorage.GetValues(AKey: string): string;
begin
  Result := '';
end;

function TSessionStorage.GetKey(AIndex: integer): string;
begin
  Result := '';
end;

function TSessionStorage.GetCount: integer;
begin
  Result := 0;
end;



end.