unit libcalendar;

interface

uses
  Web, JS, Classes;

type
  TJSCalendarSelectHandler = reference to procedure(Date: TJSDate);

  TJSCalendarOptions = class(TJSObject)
  private
    FDate: TJSDate;
    FFirstDay: NativeInt;
    FShowToday: Boolean;
    FMonths: TJSArray;
    FTodaysDate: TJSDate;
    FMultiselect: Boolean;
    FDatesFilter: Boolean;
    FShortWeekday: TJSArray;
    FPastDates: Boolean;
    FAvailableWeekDays: TJSArray;
    FAvailableDates: TJSArray;
    FSelector: string;
    FReadOnly: Boolean;
    FSelectedClass: string;
    FButtonHintPrev: string;
    FMaxDate: TJSDate;
    FButtonHintNext: string;
    FCurrentClass: string;
    FMinDate: TJSDate;
    FHeaderClass: string;
    FBackgroundClass: string;
    FSelectedDate: TJSDate;
    FWeekClass: string;
  public
    onSelect: TJSCalendarSelectHandler;
    onUnselect: TJSCalendarSelectHandler;
    property selector: string read FSelector write FSelector;
    property datesFilter: Boolean read FDatesFilter write FDatesFilter;
    property readOnly: Boolean read FReadOnly write FReadOnly;
    property pastDates: Boolean read FPastDates write FPastDates;
    property firstDay: NativeInt read FFirstDay write FFirstDay;
    property availableWeekDays: TJSArray read FAvailableWeekDays write FAvailableWeekDays;
    property availableDates: TJSArray read FAvailableDates write FAvailableDates;
    property selectedDate: TJSDate read FSelectedDate write FSelectedDate;
    property date: TJSDate read FDate write FDate;
    property todaysDate: TJSDate read FTodaysDate write FTodaysDate;
    property multiselect: Boolean read FMultiselect write FMultiselect;
    property months: TJSArray read FMonths write FMonths;
    property shortWeekday: TJSArray read FShortWeekday write FShortWeekday;
    property showToday: Boolean read FShowToday write FShowToday;
    property buttonHintNext: string read FButtonHintNext write FButtonHintNext;
    property buttonHintPrev: string read FButtonHintPrev write FButtonHintPrev;
    property maxDate: TJSDate read FMaxDate write FMaxDate;
    property minDate: TJSDate read FMinDate write FMinDate;
    property backgroundClass: string read FBackgroundClass write FBackgroundClass;
    property selectedClass: string read FSelectedClass write FSelectedClass;
    property currentClass: string read FCurrentClass write FCurrentClass;
    property weekClass: string read FWeekClass write FWeekClass;
    property headerClass: string read FHeaderClass write FHeaderClass;
  end;

  TJSCalendar = class(TJSObject)
  public
    constructor new(AOptions: TJSCalendarOptions);
    procedure init;
    procedure reset;
    procedure &set(AOptions: TJSCalendarOptions);
    procedure setSelectedYear(AYear: NativeInt);
    procedure setSelectedMonth(AMonth: NativeInt);
    procedure setSelectedDay(ADay: NativeInt);
    procedure setSelectedDate(ADate: TJSDate);
    procedure setFirstDay(ADay: NativeInt);
    procedure setMultiSelect(AMultiSelect: Boolean);
    procedure setMonths(AMonths: TJSArray);
    procedure setShortWeekdays(AWeekdays: TJSArray);
    procedure setPastDates(APastDates: Boolean);
    procedure setEnabledWeekdays(AWeekdays: TJSArray);
    procedure setDatesFilter(AFilter: Boolean);
    procedure setShowToday(AShowToday: Boolean);
    procedure setReadOnly(AReadOnly: Boolean);
    procedure setSelectedDates(ADates: TJSArray);
    procedure setButtonHintNext(AHint: string);
    procedure setButtonHintPrev(AHint: string);
    procedure setMaxDate(ADate: TJSDate);
    procedure setMinDate(ADate: TJSDate);
    procedure setBackgroundClass(AClass: string);
    procedure setSelectedClass(AClass: string);
    procedure setCurrentClass(AClass: string);
    procedure setWeekClass(AClass: string);
    procedure setHeaderClass(AClass: string);
    function getSelectedDays: TJSArray;
    function getSelectedYear: NativeInt;
    function getSelectedMonth: NativeInt;
    function getSelectedDay: NativeInt;
    function getSelectedDate: TJSDate;
    function getSelectedDateCount: NativeInt;
  end;

implementation

{ TJSCalendar }

function TJSCalendar.getSelectedDate: TJSDate;
begin
  Result := nil;
end;

function TJSCalendar.getSelectedDateCount: NativeInt;
begin
  Result := -1;
end;

function TJSCalendar.getSelectedDay: NativeInt;
begin
  Result := -1;
end;

function TJSCalendar.getSelectedDays: TJSArray;
begin
  Result := nil;
end;

function TJSCalendar.getSelectedMonth: NativeInt;
begin
  Result := -1;
end;

function TJSCalendar.getSelectedYear: NativeInt;
begin
  Result := -1;
end;

procedure TJSCalendar.init;
begin

end;

constructor TJSCalendar.new(AOptions: TJSCalendarOptions);
begin

end;

procedure TJSCalendar.reset;
begin

end;

procedure TJSCalendar.&set(AOptions: TJSCalendarOptions);
begin

end;

procedure TJSCalendar.setBackgroundClass(AClass: string);
begin

end;

procedure TJSCalendar.setButtonHintNext(AHint: string);
begin

end;

procedure TJSCalendar.setButtonHintPrev(AHint: string);
begin

end;

procedure TJSCalendar.setCurrentClass(AClass: string);
begin

end;

procedure TJSCalendar.setDatesFilter(AFilter: Boolean);
begin

end;

procedure TJSCalendar.setEnabledWeekdays(AWeekdays: TJSArray);
begin

end;

procedure TJSCalendar.setFirstDay(ADay: NativeInt);
begin

end;

procedure TJSCalendar.setHeaderClass(AClass: string);
begin

end;

procedure TJSCalendar.setMaxDate(ADate: TJSDate);
begin

end;

procedure TJSCalendar.setMinDate(ADate: TJSDate);
begin

end;

procedure TJSCalendar.setMonths(AMonths: TJSArray);
begin

end;

procedure TJSCalendar.setMultiSelect(AMultiSelect: Boolean);
begin

end;

procedure TJSCalendar.setPastDates(APastDates: Boolean);
begin

end;

procedure TJSCalendar.setReadOnly(AReadOnly: Boolean);
begin

end;

procedure TJSCalendar.setSelectedClass(AClass: string);
begin

end;

procedure TJSCalendar.setSelectedDate(ADate: TJSDate);
begin

end;

procedure TJSCalendar.setSelectedDates(ADates: TJSArray);
begin

end;

procedure TJSCalendar.setSelectedDay(ADay: NativeInt);
begin

end;

procedure TJSCalendar.setSelectedMonth(AMonth: NativeInt);
begin

end;

procedure TJSCalendar.setSelectedYear(AYear: NativeInt);
begin

end;

procedure TJSCalendar.setShortWeekdays(AWeekdays: TJSArray);
begin

end;

procedure TJSCalendar.setShowToday(AShowToday: Boolean);
begin

end;

procedure TJSCalendar.setWeekClass(AClass: string);
begin

end;

end.
