{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
unit libfaunadb;

{$mode objfpc}
{$modeswitch externalclass}

interface

uses
  JS, Web;

type
  TFaunaDbError = Class external name 'Error'
  Public
    property message : String Read FMessage;
    property name : String Read FName;
  end;

  TFaunaDbSet = class(TJSObject)
  end;

  TFaunaDbPages = class(TJSArray)
  end;

  TFaunaDbLambda = class(TJSObject)
  end;

  TFaunaDbFunction = class(TJSObject)
  end;

  TFaunaDbInstance = class(TJSObject)
  public
    property id: String read fId;
  end;

  TFaunaDbIndex = class(TJSObject)
  public
    property ref: TFaunaDbInstance read fRef;
  end;

  TFaunaDbDocument = class(TJSObject)
  public
    property data: TJSObject read fData;
    property ref: TFaunaDbInstance read fRef;
  end;

  TFaunaDbAuth = class(TJSObject)
  public
    property instance: TFaunaDbInstance read fInstance;
    property secret: String read fSecret;
  end;

  TFaunaDbQuery = class external name 'faunadb.query' (TJSObject)
  public
    function Create(aCollection: TFaunaDbInstance; paramObject: TJSObject): TJSObject;
    function CreateIndex(paramObject: TJSObject): TFaunaDbIndex;
    function Collection(aCollection: String): TFaunaDbInstance;
    function Delete(aDocRef: TFaunaDbInstance): TJSObject;
    function Exists(aReference: TJSObject): Boolean;
    function Get(aValue: JSValue): JSValue;
    function GetVar(aName: String): JSValue; external name 'Var';
    function Index(name: String): TFaunaDbInstance;
    function Lambda(aVar: String; anExpr: JSValue): TFaunaDbLambda;
    function Login(aRef: TFaunaDbSet; paramObject: TJSObject): TFaunaDbAuth;
    procedure Logout(RemoveAllTokens: Boolean);
    function Map(anArray: TJSArray; aLambda: TFaunaDbLambda): TJSArray;
    function Match(anIndex: TFaunaDbInstance): TFaunaDbSet; overload;
    function Match(anIndex: TFaunaDbInstance; aValue: String): TFaunaDbSet; overload;
    function Paginate(aSet: TFaunaDbSet): TFaunaDbPages;
    function Ref(aRef: TFaunaDbInstance): TFaunaDbInstance; overload;
    function Ref(aRef: TFaunaDbInstance; anId: String): TFaunaDbInstance; overload;
    function Select(path: JSValue; from: JSValue): JSValue;
    function Update(aDocRef: TFaunaDbInstance; paramObject: TJSObject): TJSObject;
    function theFunction(aName: String): TFaunaDbFunction; external name 'Function';
    function Call(aFunction: TFaunaDbFunction; args: TJSArray): JSValue;
  end;

  TFaunaDbClient = class  external name 'faunadb.Client' (TJSObject)
  public
    constructor New(config: TJSObject);
    function query(params: JSValue): TJSPromise;
  end;

  TFaunaDb = class external name 'faunadb' (TJSObject)
  public
    class property query: TFaunaDbQuery read fquery;
  end;

implementation
end.
